
/**
 * Title:        VeniVidiVinci<p>
 * Description:  An applet that displays visualisations of data sets and allows
 * these visualisations to be manipulated and selections made<p>
 * Copyright:    Copyright (c) Matthew Carey<p>
 * Company:      Imperial College<p>
 * @author Matthew Carey
 * @version 1.0
 */
package vishnu.testvis.visual;

import javax.swing.JEditorPane;
import javax.swing.*;
import javax.swing.text.html.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

public class Hlink extends JEditorPane
{
    public JScrollPane linkPane;
    public Vishnu currentMain;
    public int index = 0;
    public int numDisplayedDocs = 15;
    private int width, length;

    public Hlink(int width, int length , Vishnu currentMain)
    {
        this.currentMain=currentMain;
        this.width=width;
        this.length=length;
        try
        {
            jbInit();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }
    public Hlink()
    {
        this.currentMain=null;
        this.width=500;
        this.length=300;
        try
        {
            jbInit();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }

    public void jbInit() throws Exception
    {
        linkPane = new JScrollPane(this);
        linkPane.setBorder(BorderFactory.createLoweredBevelBorder());
        linkPane.setPreferredSize(new Dimension(width,length));
        linkPane.setMinimumSize(new Dimension(width,length));
        linkPane.setBorder(new javax.swing.border.EtchedBorder());
        linkPane.getVerticalScrollBar().setUnitIncrement(10);

        setLayout(new GridLayout(17,1));


        setEditorKitForContentType("text/html",new HTMLEditorKit());
        setEditorKit(new HTMLEditorKit());
        setEditable(false);

        addHyperlinkListener(new MyLinkListener());

        setVisible(true);

    }

    public class MyLinkListener implements HyperlinkListener
    {
        public void hyperlinkUpdate(HyperlinkEvent he){
            System.out.println("Inside hyperlinkevent ... ");
            HyperlinkEvent.EventType type = he.getEventType();
            System.out.println("Inside hyperlinkevent ... ");
            if (type==HyperlinkEvent.EventType.ACTIVATED)
                System.out.println("Mouse ACTIVATED -> " + he.getURL().toString());
        }
    }

    public void update()
    {
       int [] docIDs = currentMain.dataManager.getDocs();
        Vector subSet = new Vector();

        for (int i = index ; i < index + numDisplayedDocs  ; i++)
        {

            // Check that the element exists
            if (docIDs.length <= i) break;

            subSet.addElement(new Integer(docIDs[i]));
        }

        String htmlDescription = currentMain.dataManager.getDescriptionStr(subSet);

        setText(htmlDescription);

    }

    public void clear()
    {
        setText("");
    }



}
